SystemOrganization addCategory: #'IRDA2013-sorting2-Tests'!
SystemOrganization addCategory: #'IRDA2013-sorting2'!
SystemOrganization addCategory: #'IRDA2013-sorting2-Challenges'!
SystemOrganization addCategory: #'IRDA2013-sorting2-SorterClasses'!

RectangleMorph subclass: #S2ItemMorph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2ItemMorph methodsFor: 'initialization' stamp: 'db 6/8/2013 22:55:14.378'!
aboutToBeGrabbedBy: aHand
	super aboutToBeGrabbedBy: aHand.
	self disableTableLayout: true.
	Transcript show: 'you want to grab me'! !

!S2ItemMorph methodsFor: 'visual properties' stamp: 'db 5/31/2013 18:07:35.462'!
alphaHighlight

	^ 0.8! !

!S2ItemMorph methodsFor: 'accessing' stamp: 'db 5/31/2013 17:51:41.564'!
alphaHighlight: anObject

	alphaHighlight := anObject! !

!S2ItemMorph methodsFor: 'visual properties' stamp: 'db 5/31/2013 18:06:59.178'!
alphaNormal

	^ 1! !

!S2ItemMorph methodsFor: 'accessing' stamp: 'db 5/31/2013 17:51:41.582'!
alphaNormal: anObject

	alphaNormal := anObject! !

!S2ItemMorph methodsFor: 'initialization' stamp: 'db 5/31/2013 20:51:30.446'!
contents

	^self label contents.! !

!S2ItemMorph methodsFor: 'initialization' stamp: 'db 5/31/2013 17:56:29.174'!
contents: aString
	self removeAllMorphs;
		addMorph: self label.
	self label contents: aString.! !

!S2ItemMorph methodsFor: 'event handling' stamp: 'db 5/31/2013 18:04:54.708'!
handlesMouseOver: evt

	^ true! !

!S2ItemMorph methodsFor: 'visual properties' stamp: 'db 5/31/2013 17:47:41.348'!
highlight

	self color:(self color alpha: self alphaHighlight)! !

!S2ItemMorph methodsFor: 'initialization' stamp: 'db 6/21/2013 05:19:41.88'!
initialize 
	super initialize.
	self
		color: Color blue;
		borderColor: Color black;
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #center;
		wrapCentering: #center;
		enableDrag: true;
		borderWidth: 2; 
		"useRoundedCorners;"
    	setBorderStyle: #complexRaised.! !

!S2ItemMorph methodsFor: 'accessing' stamp: 'db 5/30/2013 22:21:54.576'!
label 
	^ label ifNil: [label := StringMorph new fontName: 'ComicSansMS'size: 30].! !

!S2ItemMorph methodsFor: 'accessing' stamp: 'db 5/30/2013 22:00:29.442'!
label: anObject

	label := anObject! !

!S2ItemMorph methodsFor: 'as yet unclassified' stamp: 'db 6/1/2013 16:26:35.756'!
morphicLayerNumberWithin: anOwner
	^90! !

!S2ItemMorph methodsFor: 'event handling' stamp: 'db 5/31/2013 18:03:52.786'!
mouseEnter: evt

	self	highlight.! !

!S2ItemMorph methodsFor: 'event handling' stamp: 'db 5/31/2013 18:04:08.764'!
mouseLeave: evt

	self	noHighlight.! !

!S2ItemMorph methodsFor: 'visual properties' stamp: 'db 5/31/2013 17:54:13.072'!
noHighlight

	self color:(self color alpha: self alphaNormal)! !

!S2ItemMorph methodsFor: 'accessing' stamp: 'db 5/31/2013 17:49:16.04'!
notHighlight

	self color:(self color alpha: self alphaNormal)! !

!S2ItemMorph methodsFor: 'as yet unclassified' stamp: 'db 5/31/2013 20:21:05.914'!
startDrag
	self emit.! !

!S2ItemMorph methodsFor: 'as yet unclassified' stamp: 'db 5/31/2013 20:13:11.684'!
startDrag: event fromMorph: sourceMorph 
	self emit.
	super startDrag: event fromMorph: sourceMorph.! !

PasteUpMorph subclass: #S2ItemSpaceMorph
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2ItemSpaceMorph methodsFor: 'change reporting' stamp: 'db 6/1/2013 15:52:39.206'!
addedMorph: aS2ItemMorph	
	
	aS2ItemMorph 
		position: self position;
		noHighlight.

	super addedMorph: aS2ItemMorph.
	
	
	! !

!S2ItemSpaceMorph methodsFor: 'visual properties' stamp: 'db 5/31/2013 19:06:14.058'!
borderColorHighlight

	^ self borderColorNormal darker darker.! !

!S2ItemSpaceMorph methodsFor: 'visual properties' stamp: 'db 5/31/2013 18:26:41.376'!
borderColorNormal

	^ Color white.! !

!S2ItemSpaceMorph methodsFor: 'event handling' stamp: 'db 5/31/2013 18:18:55.93'!
handlesMouseOver: evt

	^ true! !

!S2ItemSpaceMorph methodsFor: 'visual properties' stamp: 'db 5/31/2013 18:27:46.61'!
highlight

	self borderColor: self borderColorHighlight.! !

!S2ItemSpaceMorph methodsFor: 'accessing' stamp: 'db 5/31/2013 20:59:12.508'!
index

	^ index! !

!S2ItemSpaceMorph methodsFor: 'accessing' stamp: 'db 5/31/2013 20:59:12.522'!
index: anObject

	index := anObject! !

!S2ItemSpaceMorph methodsFor: 'initialization' stamp: 'db 6/21/2013 06:17:20.434'!
initialize
	super initialize.
	self enableDrop: true;
		clipSubmorphs: false;
		color: Color gray lighter;
		borderWidth: 1;
		borderColor: Color white;
		hResizing: #spaceFill.! !

!S2ItemSpaceMorph methodsFor: 'event handling' stamp: 'db 5/31/2013 20:24:44.816'!
itemDragged
	Transcript show: 'yo item dragged!!'.
	self highlightForDrop: true.! !

!S2ItemSpaceMorph methodsFor: 'as yet unclassified' stamp: 'db 6/1/2013 16:26:25.388'!
morphicLayerNumberWithin: anOwner
	^95! !

!S2ItemSpaceMorph methodsFor: 'event handling' stamp: 'db 6/1/2013 13:57:16.492'!
mouseEnter: evt

	self submorphs isEmpty ifTrue: [self highlight].! !

!S2ItemSpaceMorph methodsFor: 'event handling' stamp: 'db 5/31/2013 20:22:53.124'!
mouseLeave: evt

	self noHighlight.! !

!S2ItemSpaceMorph methodsFor: 'visual properties' stamp: 'db 5/31/2013 18:28:07.908'!
noHighlight

	self borderColor: self borderColorNormal.! !

!S2ItemSpaceMorph methodsFor: 'change reporting' stamp: 'db 5/31/2013 22:32:47.508'!
removedMorph: aMorph! !

!S2ItemSpaceMorph methodsFor: 'event handling' stamp: 'db 5/31/2013 20:22:47.418'!
repelsMorph: aMorph event: evt

    ^ (self wantsDroppedMorph: aMorph event: evt) not! !

!S2ItemSpaceMorph methodsFor: 'event handling' stamp: 'db 6/21/2013 05:18:12.812'!
wantsDroppedMorph: aMorph event: evt
	"TODO implement this with signals"
    "aMorph class = S2ItemMorph ifTrue: [
		Transcript show: '(';
			show: self index;
			show: ':';
			show: aMorph contents;
			show: ')'.
		self noHighlight.
		self owner listModel setItemAt: self index to: aMorph contents.
		^true.]"
	 ^true.
! !

PasteUpMorph subclass: #S2ListMorph
	instanceVariableNames: 'itemSpaces morphAnimations activeAnimationsCount states currentStateIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/17/2013 18:06:10.766'!
activeAnimationsCount

	^ activeAnimationsCount! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/17/2013 18:06:10.776'!
activeAnimationsCount: anObject

	activeAnimationsCount := anObject! !

!S2ListMorph methodsFor: 'animations' stamp: 'db 6/21/2013 05:00:04.106'!
animationDuration 
	^500! !

!S2ListMorph methodsFor: 'controlling' stamp: 'db 6/21/2013 17:21:23.652'!
back
	| prev |
	currentStateIndex > 1 ifTrue: [
		prev := currentStateIndex - 1.
		Transcript show: 'back pressed, move to state: ', prev asString, 
			' elements: ', (self states at: prev) elements asArray asString, String cr.	
		self visualizeState: prev].
! !

!S2ListMorph methodsFor: 'signalling' stamp: 'db 6/21/2013 03:08:16.644'!
connectTo: aS2List
	self
   		connect: aS2List
   		signal: #nextState:
   		toSelector: #saveState:.! !

!S2ListMorph methodsFor: 'animations' stamp: 'db 6/21/2013 04:57:35.892'!
createAnimationWhichMovesMorph: aMorph toIndex: anIndex
	| space |
	space := (self itemSpaces at: anIndex).
	^(AnimPropertyAnimation 
		on: aMorph
		property: #position 
		start: aMorph position 
		end: space position
		duration: self animationDuration)
		register;	
		finishBlock: [
			space addMorph: aMorph.		
			self decActiveAnimationsCount.
			self activeAnimationsCount = 0 ifTrue: [
				self onLastAnimationFinished.
				].
			].
		! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/21/2013 04:30:20.872'!
currentStateIndex

	^ currentStateIndex! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/21/2013 04:30:30.276'!
currentStateIndex: anObject

	currentStateIndex := anObject! !

!S2ListMorph methodsFor: 'animations' stamp: 'db 6/21/2013 05:00:43.488'!
decActiveAnimationsCount
	self activeAnimationsCount: self activeAnimationsCount - 1.! !

!S2ListMorph methodsFor: 'controlling' stamp: 'db 6/21/2013 17:21:41.98'!
forward
	| next |
	next := currentStateIndex + 1.
	(self states at: next) isSorted ifTrue: 
		[Transcript show: 'list is sorted!!'. ^ self].
	currentStateIndex = self states size ifTrue: 
		[Transcript show: 'reached last state but list not sorted...'. ^ self].
	
	Transcript show: 'forward pressed, move to state: ', next asString, 
		' elements: ', (self states at: next) elements asArray asString, String cr.
		
	self visualizeState: next.! !

!S2ListMorph methodsFor: 'animations' stamp: 'db 6/21/2013 04:59:26.02'!
incActiveAnimationsCount
	self activeAnimationsCount: self activeAnimationsCount + 1.! !

!S2ListMorph methodsFor: 'initialization' stamp: 'db 6/21/2013 06:16:40.71'!
initialize
	super initialize.
	self layoutPolicy: TableLayout new;
		"layoutPolicy: self ourLayoutPolicy;"
		"#topToBottom also possible"
		listDirection: #leftToRight;
		listCentering: #center;
		hResizing: #spaceFill; vResizing: #spaceFill;
		extent: 400@300;
		layoutInset: 20; cellInset: 10;
		color: (Color gray);
		states: OrderedCollection new;
		currentStateIndex: 1;
		activeAnimationsCount: 0.! !

!S2ListMorph methodsFor: 'initialization' stamp: 'db 6/21/2013 05:09:05.814'!
initializeItemSpaces: aS2List
	| morphs position |
	position := 0.
	morphs := aS2List elements collect: [:i |
		position := position + 1.
		self newItemSpace: position.		
		].	
	self itemSpaces: morphs;
		addMorphs: morphs.! !

!S2ListMorph methodsFor: 'initialization' stamp: 'db 6/21/2013 05:12:39.946'!
initializeItems: aS2List
	| position morph space |
	position := 0.
	aS2List elements do: [:i | 
		position := position + 1.
		space := (self itemSpaces at: position).
		morph := self newItem: i.
		space addMorph: morph.		
		].
! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/17/2013 18:06:10.718'!
itemSpaces

	^ itemSpaces! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/17/2013 18:06:10.732'!
itemSpaces: anObject

	itemSpaces := anObject! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/21/2013 05:03:18.088'!
morphAnimations

	^ morphAnimations ifNil: [^ morphAnimations := OrderedCollection new]! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/17/2013 18:06:10.754'!
morphAnimations: anObject

	morphAnimations := anObject! !

!S2ListMorph methodsFor: 'updating' stamp: 'db 6/21/2013 17:30:18.724'!
moveItems: aS2List
	"TODO refactor"
	| current prev currentS2List n itemToPositionMap |
	currentS2List := self states at: self currentStateIndex.
	currentS2List = aS2List 
		ifTrue: []
		ifFalse: [
			n := currentS2List elements size.
			"fill dict we use to find out new position of each item morph"
			itemToPositionMap := Dictionary new: n.
			1 to: n do: [:j |
				itemToPositionMap at: (aS2List elements at: j) put: j.
		].
		"set up animations"
		1 to: n do: [:i |
			current := aS2List elements at: i.
			prev := currentS2List elements at: i.
			( current = prev) ifFalse: [
				self moveMorphWithIndex: i toIndex: (itemToPositionMap at: prev)].
		].
		"start all animations, the last animation will call onLastAnimationFinished on finish"
		self startAnimations
	].
	! !

!S2ListMorph methodsFor: 'updating' stamp: 'db 6/21/2013 04:56:14.972'!
moveMorphWithIndex: prevIndex toIndex: currentIndex
	| animation currentSpace prevSpace morphToMove |
	self incActiveAnimationsCount.
	
	prevSpace := self submorphs at: prevIndex.
	currentSpace := self submorphs at: currentIndex.
	morphToMove := (prevSpace submorphs at: 1).
	animation := self createAnimationWhichMovesMorph: morphToMove toIndex: currentIndex.		
	self morphAnimations add: animation.! !

!S2ListMorph methodsFor: 'updating' stamp: 'db 6/21/2013 04:45:21.632'!
moveToState: aS2List
	self moveItems: aS2List.! !

!S2ListMorph methodsFor: 'initialization' stamp: 'db 6/21/2013 05:10:45.998'!
newItem: anObject
	| item |
	item := S2ItemMorph new.	
	item contents: anObject asString.
	^item! !

!S2ListMorph methodsFor: 'initialization' stamp: 'db 6/21/2013 05:08:20.898'!
newItemSpace: anObject
	| item |
	item := S2ItemSpaceMorph new.
	item index: anObject.
	^item
	! !

!S2ListMorph methodsFor: 'animations' stamp: 'db 6/21/2013 17:26:31.37'!
onLastAnimationFinished
		self morphAnimations: nil.
		(Delay forMilliseconds: 300) wait.
		"self setItemColors."
		self submorphs do: [:m|m disableTableLayout: false].! !

!S2ListMorph methodsFor: 'updating' stamp: 'db 6/21/2013 05:04:23.244'!
saveState: aS2List
	self states add: aS2List.
	aS2List isSorted ifTrue: [self visualizeState: self currentStateIndex].! !

!S2ListMorph methodsFor: 'animations' stamp: 'db 6/21/2013 05:47:23.056'!
startAnimations
	self submorphs do: [:m|m disableTableLayout: true].
	self morphAnimations do:[:a|a start: #deleteWhenFinished]! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/21/2013 03:14:25.244'!
states

	^ states! !

!S2ListMorph methodsFor: 'accessing' stamp: 'db 6/21/2013 03:14:25.262'!
states: anObject

	states := anObject! !

!S2ListMorph methodsFor: 'updating' stamp: 'db 6/21/2013 17:20:13.142'!
visualizeState: stateIndex
	| state |
	state := self states at: stateIndex.
	self itemSpaces ifNil: [self initializeItemSpaces: state].
	self currentStateIndex = stateIndex 
		ifTrue: [self initializeItems: state]
		ifFalse: [self moveToState: state].
		
	currentStateIndex := stateIndex.
	
	
	
	! !

PasteUpMorph subclass: #S2ListMorphOld
	instanceVariableNames: 'itemSpaces morphAnimations activeAnimationsCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2ListMorphOld commentStamp: 'db 5/29/2013 01:11:36.796' prior: 0!
#sada!

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/29/2013 01:14:55.642'!
activeAnimationsCount
	"TODO are animations thread safe?"
	^ activeAnimationsCount ifNil: [activeAnimationsCount := 0]! !

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/29/2013 01:13:01.818'!
activeAnimationsCount: anObject

	activeAnimationsCount := anObject! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 6/1/2013 16:12:18.26'!
actualItems

	^submorphs collect: [:m | (m submorphs at: 1) contents asInteger].! !

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/14/2013 20:52:33.47'!
animationDuration 
	^500! !

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/31/2013 22:43:12.598'!
createAnimationWhichMovesMorph: aMorph toIndex: anIndex

	| space |
	space := (self getItemSpaceAt: anIndex).

	^(AnimPropertyAnimation 
		on: aMorph
		property: #position 
		start: aMorph position 
		end: space position
		duration: self animationDuration)
		register;	
		finishBlock: [
			space addMorph: aMorph.		
			self decActiveAnimationsCount.
			self activeAnimationsCount = 0 ifTrue: [
				self onLastAnimationFinished.
				].
			].
		! !

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/29/2013 01:16:20.994'!
decActiveAnimationsCount
	self activeAnimationsCount: self activeAnimationsCount - 1.! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 5/30/2013 20:30:02.832'!
getItemSpaceAt: anIndex
	^self submorphs at: anIndex.
! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 6/1/2013 15:46:21.526'!
getSizeForItem
	| leftSpaceForItems |
	leftSpaceForItems := ((self width - (2 * self layoutInset) - (self cellInset * (self listModel items size - 1)))).
	^ (leftSpaceForItems / self listModel items size) asInteger.! !

!S2ListMorphOld methodsFor: 'as yet unclassified' stamp: 'db 6/17/2013 18:03:14.42'!
handleElements: anOrderedCollection
	(self itemSpaces isNil or: (self itemSpaces size <> anOrderedCollection)) ifTrue: [
		self intializeItemSpaces
		].! !

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/29/2013 01:16:01.33'!
incActiveAnimationsCount
	self activeAnimationsCount: self activeAnimationsCount + 1.! !

!S2ListMorphOld methodsFor: 'nil' stamp: 'db 6/17/2013 17:58:40.648'!
initialize
	super initialize.
	self "ourLayoutPolicy: TableLayout new;
		layoutPolicy: self ourLayoutPolicy;"
		"#topToBottom also possible"
		listDirection: #leftToRight;
		listCentering: #center;
		hResizing: #spaceFill; vResizing: #spaceFill;
		extent: 400@300;
		layoutInset: 20; cellInset: 10;
		color: (Color gray).! !

!S2ListMorphOld methodsFor: 'initialization' stamp: 'db 6/17/2013 18:05:36.018'!
initializeItemSpaces
	| morphs position |
	position := 1.
	morphs := self listModel items collect: [:i |
		self newItemSpace: position.
		position := position + 1.
		].	
	
	self addMorphs: morphs.! !

!S2ListMorphOld methodsFor: 'initialization' stamp: 'db 6/1/2013 16:43:45.978'!
initializeItems
	| position morph space |
	position := 0.
	self listModel items do: [:i | 
		position := position + 1.
		space := (self getItemSpaceAt: position).
		morph := self newItem: i withColor: (self listModel getItemColor: position) andSizeLike: space.
		space addMorph: morph.	
		].
! !

!S2ListMorphOld methodsFor: 'accessing' stamp: 'db 6/17/2013 18:06:10.718'!
itemSpaces

	^ itemSpaces! !

!S2ListMorphOld methodsFor: 'accessing' stamp: 'db 6/17/2013 18:06:10.732'!
itemSpaces: anObject

	itemSpaces := anObject! !

!S2ListMorphOld methodsFor: 'accessing' stamp: 'db 5/14/2013 02:05:30.117'!
listModel

	^ listModel! !

!S2ListMorphOld methodsFor: 'accessing' stamp: 'db 5/14/2013 02:05:30.131'!
listModel: anObject

	listModel := anObject! !

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/29/2013 03:21:46.016'!
morphAnimations

	^morphAnimations ifNil: [morphAnimations := OrderedCollection new].

! !

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/29/2013 03:22:01.388'!
morphAnimations: anObject

	morphAnimations := anObject! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 6/8/2013 23:17:22.954'!
moveItems

	((self actualItems) = (self listModel items asArray))
		ifTrue: [self setItemColors]
		ifFalse: [self layoutPolicy: nil; moveItemsImpl].
	
	! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 6/1/2013 16:16:56.716'!
moveItemsImpl
	| current prev dict n |
	n := self listModel size.
	"fill dict we use to find out new position of each item morph"
	dict := Dictionary new: n.
	1 to: n do: [:j |
		dict at: (self listModel items at: j) put: j.
	].
	"set up animations"
	1 to: n do: [:i |
		current := self listModel items at: i.
		prev := self actualItems at: i.
		( current = prev)
			ifFalse: [
				self moveMorphWithIndex: i toIndex: (dict at: prev)
				].
		].
	"start all animations, the last animation will call highlightActiveItems on finish"
	self startAnimations
	
	
	! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 6/8/2013 22:57:29.824'!
moveMorphWithIndex: prevIndex toIndex: currentIndex
	| animation currentSpace prevSpace morphToMove |
	self incActiveAnimationsCount.
	
	prevSpace := self submorphs at: prevIndex.
	currentSpace := self submorphs at: currentIndex.
	morphToMove := (prevSpace submorphs at: 1).
	animation := self createAnimationWhichMovesMorph: morphToMove toIndex: currentIndex.		
	self morphAnimations add: animation.! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 5/30/2013 21:58:12.01'!
newItem: anObject
	| item |
	item := S2ItemMorph new.	
	item contents: anObject asString.
	^item
	! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 5/30/2013 22:23:49.674'!
newItem: anObject withColor: aColor andSizeLike: aMorph
	| item |
	item := self newItem: anObject.
	item color: aColor;
		width: aMorph width;
		height: aMorph height.
	^item
	! !

!S2ListMorphOld methodsFor: 'submorphs' stamp: 'db 5/31/2013 21:00:32.022'!
newItemSpace: anObject size: aPoint
	| item |
	item := S2ItemSpaceMorph new.
	item color: Color gray lighter;
		width: aPoint x;
		height: aPoint y;
		borderWidth: 1;
		borderColor: Color white;
		index: anObject.
	^item
	! !

!S2ListMorphOld methodsFor: 'updating' stamp: 'db 6/8/2013 23:04:32.546'!
onLastAnimationFinished
		self morphAnimations: nil.
		(Delay forMilliseconds: 300) wait.
		self setItemColors.
		self layoutPolicy: self ourLayoutPolicy.! !

!S2ListMorphOld methodsFor: 'accessing' stamp: 'db 6/8/2013 23:05:07.492'!
ourLayoutPolicy

	^ ourLayoutPolicy! !

!S2ListMorphOld methodsFor: 'accessing' stamp: 'db 6/8/2013 23:05:07.508'!
ourLayoutPolicy: anObject

	ourLayoutPolicy := anObject! !

!S2ListMorphOld methodsFor: 'visual properties' stamp: 'db 5/31/2013 22:06:22.626'!
setItemColor: anIndex
	| morph |
	morph := (self submorphs at: anIndex) submorphs at: 1.
	morph ifNotNil: [morph color: (self listModel getItemColor: anIndex)].! !

!S2ListMorphOld methodsFor: 'visual properties' stamp: 'db 5/29/2013 03:16:24.152'!
setItemColors
	(1 to: (self listModel size)) do: [:i |
		self setItemColor: i]! !

!S2ListMorphOld methodsFor: 'animations' stamp: 'db 5/29/2013 03:27:01.422'!
startAnimations
	self morphAnimations do:[:a|a start: #deleteWhenFinished]! !

!S2ListMorphOld methodsFor: 'updating' stamp: 'db 6/8/2013 23:16:15.696'!
update: aListModel
	"observes list model for changes"
	self listModel: aListModel.
	self actualItems isEmptyOrNil 
		ifTrue: [ self initializeItemSpaces;
				initializeItems.				
			] ifFalse: [ self moveItems ].
	

! !

Object subclass: #S2AbstractChallenge
	instanceVariableNames: 'sorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:57:11.695'!
challengeDescription
	^'MyDescription'! !

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:57:28.472'!
challengeName
	^'MyName'! !

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 12:41:04.902'!
challengeNumber
	^nil! !

!S2AbstractChallenge class methodsFor: 'initializing' stamp: 'AT 5/27/2013 12:43:15.562'!
newWithNumber: nr
	|class|
	class := self.
	subclasses do: [:each |
		each challengeNumber = nr
		ifTrue: [class := each].  
	].
	^ (class new)! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:58:39.474'!
description
	^self class challengeName.! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:58:01.242'!
name
	^ self class challengeName.! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'AT 5/27/2013 12:37:30.193'!
number
	^challengeNumber! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:47:07.364'!
onWin
	self halt.
	self emit.! !

!S2AbstractChallenge methodsFor: 'starting' stamp: 'AT 5/27/2013 12:59:16.155'!
setup: morph! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:47:48.863'!
sorted
	self win! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:48:52.523'!
sorter
	^self subclassResponsibility.! !

!S2AbstractChallenge methodsFor: 'starting' stamp: 'AT 5/27/2013 12:27:58.434'!
start
	'instructions to set up the challenge UI'! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:48:00.519'!
win
	self emit.! !

S2AbstractChallenge subclass: #S2AutomaticBubblesortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AutomaticBubblesortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:20:43.805'!
sorter
	^ S2BubbleSorter! !

S2AbstractChallenge subclass: #S2AutomaticQuickSortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AutomaticQuickSortChallenge methodsFor: 'as yet unclassified' stamp: 'db 6/21/2013 03:20:10.612'!
sorter
	^S2QuickSorter! !

S2AbstractChallenge subclass: #S2Challenge1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:56:36.502'!
challengeDescription
	'Do something'! !

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:56:21.99'!
challengeName
	^'Challenge 1: Sort the List'! !

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 12:41:26.714'!
challengeNumber
 ^1! !

!S2Challenge1 methodsFor: 'starting' stamp: 'db 6/17/2013 17:46:35.912'!
setup: morph
| listModel listMorph sorter b |
	
	listModel := S2ListModel new.
	listModel items: (1 to: 7) asOrderedCollection shuffled.
	
	listMorph := S2ListMorphOld new.
	"observer pattern"
	listModel addDependent: listMorph.
	listModel changed.
		
	sorter :=	S2BubbleSorter new.
	sorter model: listModel.
	self connect: sorter signal: #onSorted toSelector: #sorted. 
	
	morph addMorph: listMorph.
	listMorph position: morph position + (0@25).

	b := SimpleButtonMorph new.
	b color: Color green;
	label: 'Next Sort Step';
	target: sorter;
	actionSelector: #nextStep;
	setBalloonText: 'click to sort'.
	morph addMorph: b.
	b position: morph position! !

!S2Challenge1 methodsFor: 'starting' stamp: 'db 6/17/2013 17:46:39.964'!
start
| listModel listMorph sorter |
	
	listModel := S2ListModel new.
	listModel items: (1 to: 7) asOrderedCollection shuffled.
	
	listMorph := S2ListMorphOld new.
	"observer pattern"
	listModel addDependent: listMorph.
	listModel changed.
		
	sorter :=	S2BubbleSorter new.
	sorter model: listModel.
	
	"self showAlert: listMorph.

	b := SimpleButtonMorph new.
	b color: Color green;
	label: 'Next Sort Step';
	target: sorter;
	actionSelector: #nextStep;
	setBalloonText: 'click to sort'.
	self addMorph: b."! !

S2AbstractChallenge subclass: #S2FreeSortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2FreeSortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:25:18.985'!
sorter
	sorter ifNil:[
		sorter := S2BubbleSorter new.].
	^ sorter! !

S2AbstractChallenge subclass: #S2ManualBubblesortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2ManualBubblesortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:23:01.561'!
sorter
	sorter ifNil:[
		sorter := S2BubbleSorter new.].
	^ sorter! !

Object subclass: #S2AbstractFocusedIndicesEvaluator
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractFocusedIndicesEvaluator class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:38:38.727'!
newWithList: aList
|me|
	me := self new.
	me list: aList. 
	^me.! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:25:37.253'!
compareFocusedElements
	^self subclassResponsibility! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:19:42.566'!
evaluateFocusedElements
	(self compareFocusedElements) ifTrue: [
		self switchFocusedElements.
	].! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:37:08.98'!
list

	^ list! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:37:08.996'!
list: anObject

	list := anObject! !

!S2AbstractFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:40:54.677'!
switchFocusedElements
	self list switchElementAt: (self list firstFocusedIndex)
		withElementAt: (self list secondFocusedIndex).! !

S2AbstractFocusedIndicesEvaluator subclass: #S2BubblesortFocusedIndicesEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:22:50.623'!
compareFocusedElements
	^self list firstFocusedElement > self list secondFocusedElement! !

S2AbstractFocusedIndicesEvaluator subclass: #S2QuicksortFocusedIndicesEvaluator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortFocusedIndicesEvaluator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:22:04.461'!
compareFocusedElements
	^(self list firstFocusedElement > self list pivotElement) and: (self list secondFocusedElement < self list pivotElement).! !

Object subclass: #S2AbstractFocusedIndicesFinder
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractFocusedIndicesFinder class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:38:34.39'!
newWithList: aList
|me|
	me := self new.
	me list: aList. 
	^me.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/17/2013 16:07:38.602'!
initFirstFocusedIndex
	^self list leftBoundIndex! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/17/2013 16:15:19.407'!
initPivotIndex
	^self subclassResponsibility! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/17/2013 16:15:31.031'!
initSecondFocusedIndex
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/17/2013 16:17:20.917'!
initializeFocusedIndices
|list|
	list := self list.
	list updateFirstFocusedIndex: (self initFirstFocusedIndex).
	list updateSecondFocusedIndex: (self initSecondFocusedIndex).
	list updatePivotIndex: (self initPivotIndex).! !

!S2AbstractFocusedIndicesFinder methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:36:44.487'!
list

	^ list! !

!S2AbstractFocusedIndicesFinder methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:36:44.508'!
list: anObject

	list := anObject! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/17/2013 15:56:01.442'!
nextFirstFocusedIndex
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/17/2013 15:59:51.966'!
nextFocusedElementsIndices
|list firstUpdate secondUpdate|
	list := self list.
	(list firstFocusedIndex isNil or: (list secondFocusedIndex isNil)) ifTrue: [
		self initializeFocusedIndices].
	firstUpdate := self shouldUpdateFirstFocusedIndex.
	secondUpdate := self shouldUpdateSecondFocusedIndex.
	firstUpdate ifTrue: [
		list updateFirstFocusedIndex: (self nextFirstFocusedIndex)].
	(secondUpdate and: (self updateBothFocusesAtOnce or: firstUpdate not)) ifTrue: [
		list updateSecondFocusedIndex: (self nextSecondFocusedIndex).].! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/17/2013 15:55:57.649'!
nextSecondFocusedIndex
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/17/2013 15:57:23.586'!
shouldUpdateFirstFocusedIndex
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/17/2013 15:59:15.435'!
shouldUpdateSecondFocusedIndex
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'subclass responsibility' stamp: 'AT 6/16/2013 16:41:34.243'!
updateBothFocusesAtOnce
	^self subclassResponsibility.! !

!S2AbstractFocusedIndicesFinder methodsFor: 'focussing' stamp: 'AT 6/17/2013 16:26:32.671'!
updateFocusedElementsIndices
|list i j|
	list := self list.
	(list firstFocusedIndex isNil or: (list secondFocusedIndex isNil)) 
		ifTrue: [self initializeFocusedIndices]
		ifFalse: [i := list firstFocusedIndex.
			j := list secondFocusedIndex.
			self nextFocusedElementsIndices.
			"The focus should change each time. If not, something went wrong."
			(i = list firstFocusedIndex and: (j = list secondFocusedIndex)) ifTrue: [
				self error: 'I got stuck'.].].! !

S2AbstractFocusedIndicesFinder subclass: #S2BubblesortFocusedIndicesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:12:20.68'!
initPivotIndex
	^nil! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:12:39.347'!
initSecondFocusedIndex
	^self list leftBoundIndex + 1! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:54:35.968'!
nextFirstFocusedIndex
	^self list firstFocusedIndex + 1! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:56:46.088'!
nextSecondFocusedIndex
	^self list secondFocusedIndex + 1! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:57:37.224'!
shouldUpdateFirstFocusedIndex
	^true! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:57:45.921'!
shouldUpdateSecondFocusedIndex
	^true! !

!S2BubblesortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 00:27:16.293'!
updateBothFocusesAtOnce
	^true! !

S2AbstractFocusedIndicesFinder subclass: #S2QuicksortFocusedIndicesFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:13:01.759'!
initPivotIndex
	^self list rightBoundIndex.! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:15:03.179'!
initSecondFocusedIndex
|left right|
	left := self list leftBoundIndex.	
	right := self list rightBoundIndex.
	(right > left) ifTrue: [^right-1] ifFalse: [^right]! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:55:40.501'!
nextFirstFocusedIndex
	^self list firstFocusedIndex + 1! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:56:22.159'!
nextSecondFocusedIndex
	^self list secondFocusedIndex - 1! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:58:29.277'!
shouldUpdateFirstFocusedIndex
	^self list firstFocusedElement <= self list pivotElement.! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:58:52.291'!
shouldUpdateSecondFocusedIndex
	^self list secondFocusedElement >= self list pivotElement.! !

!S2QuicksortFocusedIndicesFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 16:41:51.576'!
updateBothFocusesAtOnce
	^false! !

Object subclass: #S2AbstractIterator
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractIterator class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:38:28.133'!
newWithList: aList
|me|
	me := self new.
	me list: aList. 
	^me.! !

!S2AbstractIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:17:54.813'!
abortFocusing
	^self subclassResponsibility.! !

!S2AbstractIterator methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:36:20.075'!
list

	^ list! !

!S2AbstractIterator methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:36:20.094'!
list: anObject

	list := anObject! !

!S2AbstractIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:19:18.007'!
nextFocusedIndicesIteration
	^self list firstFocusedIndex isNil or: [self list secondFocusedIndex isNil] or: [(self abortFocusing) not]! !

!S2AbstractIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:19:26.244'!
nextListPartIteration
	^(self list elements size = self list sortedIndices size) not! !

S2AbstractIterator subclass: #S2BubblesortIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:18:21.223'!
abortFocusing
	(self list sortedIndices size > 0) 
		ifTrue: [^self list secondFocusedIndex >= self list sortedIndices first]
		ifFalse: [^self list secondFocusedIndex > self list elements size]! !

S2AbstractIterator subclass: #S2QuicksortIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortIterator methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:18:37.607'!
abortFocusing
	^self list firstFocusedIndex >= self list secondFocusedIndex.! !

Object subclass: #S2AbstractListPartFinder
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractListPartFinder class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 15:38:22.505'!
newWithList: aList
|me|
	me := self new.
	me list: aList. 
	^me.! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:32:32.151'!
findLeftIndex
	^self subclassResponsibility.! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:33:05.366'!
findRightIndex
	^self subclassResponsibility! !

!S2AbstractListPartFinder methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:35:26.647'!
list

	^ list! !

!S2AbstractListPartFinder methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:35:26.665'!
list: anObject

	list := anObject! !

!S2AbstractListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:38:22.236'!
updateListPartIndices
	self list updateLeftBoundaryIndex: self findLeftIndex.
	self list updateRightBoundaryIndex: self findRightIndex.! !

S2AbstractListPartFinder subclass: #S2BubblesortListPartFinder
	instanceVariableNames: 'left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:32:50.947'!
findLeftIndex
	"Finds the first index that is not sorted yet"
	^1! !

!S2BubblesortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:40:27.744'!
findRightIndex
	self list sortedIndices size > 0 ifTrue: [^self list sortedIndices first - 1] ifFalse: [^self list elements size]! !

S2AbstractListPartFinder subclass: #S2QuicksortListPartFinder
	instanceVariableNames: 'left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:27:48.455'!
findLeftIndex
	"Finds the first index that is not sorted yet"
	^(1 to: self list elements size) detect: [:ea | (self list sortedIndices includes: ea) not] ifNone: [nil].! !

!S2QuicksortListPartFinder methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:37:49.858'!
findRightIndex
	^(1 to: self list elements size) detect: [:ea | 
		(self list sortedIndices includes: (ea)) not and: ((self list sortedIndices includes: ea + 1) or: (ea = self list elements size)).
	] ifNone: [nil].! !

Object subclass: #S2AbstractListPartSorter
	instanceVariableNames: 'list focusedIndexFinder focusedIndexEvaluator iterator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractListPartSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:21:07.698'!
newWithList: anS2List
|me|
	me := self new.
	me setupWithList: anS2List.
	^me.! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.342'!
focusedIndexEvaluator

	^ focusedIndexEvaluator! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.353'!
focusedIndexEvaluator: anObject

	focusedIndexEvaluator := anObject! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.312'!
focusedIndexFinder

	^ focusedIndexFinder! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.328'!
focusedIndexFinder: anObject

	focusedIndexFinder := anObject! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.371'!
iterator

	^ iterator! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/16/2013 14:40:32.383'!
iterator: anObject

	iterator := anObject! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:35:55.005'!
list

	^ list! !

!S2AbstractListPartSorter methodsFor: 'accessing' stamp: 'AT 6/17/2013 15:35:55.022'!
list: anObject

	list := anObject! !

!S2AbstractListPartSorter methodsFor: 'initialization' stamp: 'AT 6/17/2013 16:38:48.891'!
resetFocusedIndices
	self list updateFirstFocusedIndex: nil.
	self list updateSecondFocusedIndex: nil.
	self list updatePivotIndex: nil.! !

!S2AbstractListPartSorter methodsFor: 'sorting' stamp: 'AT 6/17/2013 17:21:18.892'!
setupWithList: list
	^self subclassResponsibility.! !

!S2AbstractListPartSorter methodsFor: 'sorting' stamp: 'AT 6/17/2013 16:42:00'!
sortListPart
	"imitiating do-while loop"
	self focusedIndexFinder updateFocusedElementsIndices.
	[ self iterator nextFocusedIndicesIteration ] whileTrue:
		[ self focusedIndexEvaluator evaluateFocusedElements.
		self focusedIndexFinder updateFocusedElementsIndices. ].
	self updatePivotPosition.
	self updateSortedIndices.
	self resetFocusedIndices.! !

!S2AbstractListPartSorter methodsFor: 'sorting' stamp: 'AT 6/17/2013 16:39:37.702'!
updatePivotPosition
	^self subclassResponsibility.! !

!S2AbstractListPartSorter methodsFor: 'sorting' stamp: 'AT 6/17/2013 16:39:43.935'!
updateSortedIndices
	^self subclassResponsibility.! !

S2AbstractListPartSorter subclass: #S2BubblesortListPartSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubblesortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:19:35.109'!
setupWithList: list
	self list: list.
	self focusedIndexFinder: (S2BubblesortFocusedIndicesFinder newWithList: list).
	self focusedIndexEvaluator: (S2BubblesortFocusedIndicesEvaluator newWithList: list).
	self iterator: (S2BubblesortIterator newWithList: list).! !

!S2BubblesortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:41:35.019'!
updatePivotPosition! !

!S2BubblesortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 16:41:29.078'!
updateSortedIndices
"Todo: make me just return values and update in superclass"
	self list addIndexAsSorted: self list firstFocusedIndex.! !

S2AbstractListPartSorter subclass: #S2QuicksortListPartSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuicksortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:20:37.678'!
setupWithList: list
	self list: list.
	self focusedIndexFinder: (S2QuicksortFocusedIndicesFinder newWithList: self list).
	self focusedIndexEvaluator: (S2QuicksortFocusedIndicesEvaluator newWithList: self list).
	self iterator: (S2QuicksortIterator newWithList: self list).! !

!S2QuicksortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 18:43:36.207'!
updatePivotPosition
	self list pivotElement > self list firstFocusedElement
	ifTrue: [self list insertPivotAt: (self list firstFocusedIndex + 1)]
	ifFalse: [self list insertPivotAt: (self list firstFocusedIndex)]! !

!S2QuicksortListPartSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 18:43:31.46'!
updateSortedIndices
	self list addIndexAsSorted: self list pivotIndex.! !

Object subclass: #S2AbstractSorter
	instanceVariableNames: 'list iterator listPartFinder listPartSorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2AbstractSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:28:33.137'!
newWithElements: aCollection
|me|
	me := self new.
	me setupWithList: (S2List newWithElements: (aCollection asOrderedCollection)).
	^me.! !

!S2AbstractSorter class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:28:38.321'!
newWithList: anS2List
|me|
	me := self new.
	me setupWithList: anS2List.
	^me.! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/16/2013 17:09:15.602'!
initialLeftBoundIndexWithinElements: elements
	^self subclassResponsibility.! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/16/2013 17:09:23.32'!
initialRightBoundIndexWithinElements: elements
	^self subclassResponsibility.! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/16/2013 17:09:03.264'!
initializeBoundariesInList: list
	list leftBoundIndex: (self initialLeftBoundIndexWithinElements: list elements).
	list rightBoundIndex: (self initialRightBoundIndexWithinElements: list elements).! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.445'!
iterator

	^ iterator! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.458'!
iterator: anObject

	iterator := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.416'!
list

	^ list! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/17/2013 17:05:55.984'!
list: anObject
	list := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.476'!
listPartFinder

	^ listPartFinder! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.489'!
listPartFinder: anObject

	listPartFinder := anObject! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.5'!
listPartSorter

	^ listPartSorter! !

!S2AbstractSorter methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:03:44.511'!
listPartSorter: anObject

	listPartSorter := anObject! !

!S2AbstractSorter methodsFor: 'setup' stamp: 'AT 6/17/2013 17:26:58.32'!
setupWithList: anS2List
	^self subclassResponsibility.! !

!S2AbstractSorter methodsFor: 'sorting' stamp: 'db 6/21/2013 04:07:13.308'!
sort
	Transcript clear.
	Transcript show: self list elements asString, String cr.
	[ self iterator nextListPartIteration ] whileTrue: 
		[ self listPartFinder updateListPartIndices.
		self listPartSorter sortListPart.].
	Transcript show: 'sorted!!', String cr.
	self list updateSorted: true.! !

S2AbstractSorter subclass: #S2BubbleSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2BubbleSorter commentStamp: 'db 5/28/2013 22:10:24.268' prior: 0!
TODO subclassing morph only for stepping here..move this logic to challenge/appmorph?!

!S2BubbleSorter methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:27:41.484'!
setupWithList: anS2List
	self list: anS2List.
	self iterator: (S2BubblesortIterator newWithList: anS2List).
	self listPartFinder: (S2BubblesortListPartFinder newWithList: anS2List).
	self listPartSorter: (S2BubblesortListPartSorter newWithList: anS2List).! !

S2AbstractSorter subclass: #S2QuickSorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2QuickSorter methodsFor: 'initializing' stamp: 'AT 6/17/2013 17:28:14.67'!
setupWithList: anS2List
	self list: anS2List.
	self iterator: (S2QuicksortIterator newWithList: self list).
	self listPartFinder: (S2QuicksortListPartFinder newWithList: self list).
	self listPartSorter: (S2QuicksortListPartSorter newWithList: self list).! !

Object subclass: #S2App
	instanceVariableNames: 'challenges morph listModel challengeIndex challenge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

S2App class
	instanceVariableNames: 'IRDA2013 sorting2'!

!S2App commentStamp: 'AT 5/13/2013 19:37:58.967' prior: 0!
"The sorting2 Application, comes in a SystemWindow."!

S2App class
	instanceVariableNames: 'IRDA2013 sorting2'!

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 16:44:44.937'!
challenge

	^ challenge! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 16:44:44.951'!
challenge: anObject

	challenge := anObject! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:41:56.609'!
challengeIndex

	^ challengeIndex! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:41:56.619'!
challengeIndex: anObject

	challengeIndex := anObject! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:32:23.55'!
challenges

	^ challenges! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:32:23.562'!
challenges: anObject

	challenges := anObject! !

!S2App methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:14:36.409'!
firstChallenge 
	^ self challenges at: 1.! !

!S2App methodsFor: 'initialization' stamp: 'db 6/21/2013 03:22:17.932'!
initialize

	super initialize.
	self challenges: {S2FreeSortChallenge. S2AutomaticBubblesortChallenge. S2ManualBubblesortChallenge. S2AutomaticQuickSortChallenge}.
	self challengeIndex: 4.
	self morph: (S2AppMorph newWithApp: self).
	self morph
		openInWindowLabeled: 'Sorting';
		showStartScreen.! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 16:15:55.654'!
listModel

	^ listModel! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 16:15:55.666'!
listModel: anObject

	listModel := anObject! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 16:18:40.8'!
morph

	^ morph! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 16:18:40.81'!
morph: anObject

	morph := anObject! !

!S2App methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:45:41.047'!
nextChallenge 
	
	self challengeIndex: self challengeIndex + 1. 
	^ self challenges at: self challengeIndex.! !

!S2App methodsFor: 'as yet unclassified' stamp: 'db 6/21/2013 06:13:38.62'!
resetModel
	self challenge sorter stopStepping.
	"TODO self listModel items: (1 to: 8) asOrderedCollection shuffled."! !

!S2App methodsFor: 'initialization' stamp: 'db 6/21/2013 06:14:19.414'!
start: aChallengeClass
	|morph elements list sorter |
	self challenge: aChallengeClass new.
	
	morph := S2ListMorph new.
	list := S2List new.
	morph connectTo: list.	
	elements := (1 to: 8) asOrderedCollection shuffled.
	list setupList: elements.

	sorter := S2QuickSorter new.
	sorter setupWithList: list.
	sorter sort.
	
	self morph showInMain: morph.
	self morph initializeControlButtons: morph.! !

!S2App methodsFor: 'initialization' stamp: 'JB 6/10/2013 16:13:04.537'!
startFirstChallenge 
	self start: self firstChallenge.! !

!S2App methodsFor: 'initialization' stamp: 'JB 6/10/2013 16:01:59.206'!
startNextChallenge
	self start: self nextChallenge.! !

Object subclass: #S2List
	instanceVariableNames: 'sortedIndices elements leftBoundIndex rightBoundIndex firstFocusedIndex secondFocusedIndex pivotIndex partitions activePartitions isSorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-SorterClasses'!

!S2List class methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 17:02:09.927'!
newWithElements: aCollection
|me|
	me := self new.
	me setupList: (aCollection asOrderedCollection).
	^me.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 19:09:14.38'!
activePartitions

	^ activePartitions! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 19:09:14.395'!
activePartitions: anObject

	activePartitions := anObject! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:38:24.566'!
addElementAt: i toPartitionNo: p
|from to newFrom newTo |
	from := (self partitions select: [:ea | ea includes: i]) first.
	to := self partitions at: p.
	newFrom := from copy asOrderedCollection.
	newTo := to copy asOrderedCollection.
	newFrom remove: i.
	newTo add: i.
	self partitions add: (newFrom asSortedCollection asArray) after: from.
	self partitions remove: from.
	self partitions add: (newTo asSortedCollection asArray) after: to.
	self partitions remove: to.
	
	self signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:38:37.778'!
addIndexAsSorted: idx
	Transcript show:'Sorted: ',idx asString, String cr.
	self sortedIndices add: idx.
	"Transcript show: self elements asString, String cr."
	
	self signalStateChange.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/11/2013 17:01:33.217'!
elements

	^ elements! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:40.812'!
elements: anObject

	elements := anObject.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:14:22.772'!
firstFocusedElement
	(self firstFocusedIndex isNil or: [self firstFocusedIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self firstFocusedIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.685'!
firstFocusedIndex

	^ firstFocusedIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.759'!
firstFocusedIndex: anObject

	firstFocusedIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'db 6/21/2013 04:04:21.408'!
initialize
	super initialize.
	self elements: #() asOrderedCollection;
		sortedIndices: #() asSortedCollection;
		isSorted: false.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:42:40.578'!
insertPivotAt: p
|templeft tempmiddle tempright copy|
	Transcript show:'Moving Pivot from ',self pivotIndex asString, ' to ', p asString, String cr.
	copy := self elements copy.
	(self pivotIndex > p) 
		ifTrue: [templeft := self elements copyFrom: 1 to: p-1.
			tempmiddle := self elements copyFrom: p to: self pivotIndex-1.
			tempright := self elements copyFrom: (self pivotIndex + 1) to: self elements size.
			self elements: templeft, self pivotElement asOrderedCollection,tempmiddle, tempright.].
	(self pivotIndex < p) ifTrue: [templeft := self elements copyFrom: 1 to: self pivotIndex -1.
			tempmiddle := self elements copyFrom: (self pivotIndex + 1) to: p-1.
			tempright := self elements copyFrom: p to: self elements size.
			self elements: templeft,tempmiddle,self pivotElement asOrderedCollection, tempright.].
	self updatePivotIndex: p.
	
	self signalStateChange.! !

!S2List methodsFor: 'accessing' stamp: 'db 6/21/2013 04:04:27.484'!
isSorted

	^ isSorted.! !

!S2List methodsFor: 'accessing' stamp: 'db 6/21/2013 03:50:51.99'!
isSorted: anObject

	isSorted := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.305'!
leftBoundIndex

	^ leftBoundIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.319'!
leftBoundIndex: anObject

	leftBoundIndex := anObject! !

!S2List methodsFor: 'signalling' stamp: 'db 6/21/2013 03:09:13.372'!
nextState: aS2List
	self emit.
	! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 19:09:14.348'!
partitions

	^ partitions! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 19:09:14.365'!
partitions: anObject

	partitions := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:12:41.195'!
pivotElement
	(self pivotIndex isNil or: [self pivotIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self pivotIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.804'!
pivotIndex

	^ pivotIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.817'!
pivotIndex: anObject

	pivotIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.331'!
rightBoundIndex

	^ rightBoundIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:29:20.345'!
rightBoundIndex: anObject

	rightBoundIndex := anObject! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/17/2013 10:14:28.961'!
secondFocusedElement
	(self secondFocusedIndex isNil or: [self secondFocusedIndex > self elements size]) ifTrue: [^nil].
	^ self elements at: self secondFocusedIndex.! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.775'!
secondFocusedIndex

	^ secondFocusedIndex! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 16:26:46.79'!
secondFocusedIndex: anObject

	secondFocusedIndex := anObject! !

!S2List methodsFor: 'initialization' stamp: 'AT 6/17/2013 19:21:26.404'!
setupList: anObject
	self elements: anObject asOrderedCollection.
	self partitions: self elements copy.! !

!S2List methodsFor: 'debugging' stamp: 'db 6/21/2013 03:34:51.678'!
showDebugString
	"| vars idx stamp |
	stamp := DateAndTime now asString.
	Transcript show: '###start: ', stamp, String cr.
	idx := 1.
	vars := self class allInstVarNames collect: [:a | self instVarNamed: a].
	vars do: [:a | | name |
		name := self class allInstVarNames at: idx.
		idx := idx + 1.
		Transcript show: name, ': '.
		(a isNil not and: (a isKindOf: SequenceableCollection)) 
			ifTrue: [Transcript show: a asArray asString, String cr.] 
			ifFalse: [Transcript show: a asString, String cr.] 
		].
	Transcript show: '###end: ', stamp, String cr."
	! !

!S2List methodsFor: 'signalling' stamp: 'db 6/21/2013 03:27:12.218'!
signalStateChange
	self nextState: (self copy).! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:09.23'!
sortedIndices

	^ sortedIndices! !

!S2List methodsFor: 'accessing' stamp: 'AT 6/16/2013 15:51:09.248'!
sortedIndices: anObject

	sortedIndices := anObject! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:42:31.384'!
splitAfter: idx
|toSplit left right|
	Transcript show:'SplitAfter: ',idx asString, String cr.
	toSplit := self partitions select: [:ea | (ea includes: idx)].
	toSplit ifNotNil: [
		toSplit := toSplit first.
		(idx = (toSplit last)) ifFalse:[
			left := toSplit copyFrom: 1 to: (toSplit indexOf: idx).
			right := toSplit copyFrom: ((toSplit indexOf: idx) + 1) to: (toSplit size).
			self partitions add: left after: toSplit.
			self partitions add: right after: left.
			self partitions remove: toSplit.]].
	
	self signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:42:17.706'!
switchElementAt: i withElementAt: j
|temp|
	Transcript show:'Switching element at ',i asString, ' with ', j asString, String cr.
	temp := self elements at: i.
	self elements at: i put: (self elements at: j).
	self elements at: j put: temp.
	Transcript show: self elements asString, String cr.
	self signalStateChange.
! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:41:40.492'!
updateFirstFocusedIndex: idx
	Transcript show:'First focus: ',idx asString, String cr.
	self firstFocusedIndex: idx;
		signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:41:33.604'!
updateLeftBoundaryIndex: idx
	Transcript show:'Left bound: ',idx asString, String cr.
	self leftBoundIndex: idx;
		signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:41:26.68'!
updatePivotIndex: idx
	Transcript show:'Pivot: ',idx asString, String cr.
	self pivotIndex: idx;
		signalStateChange.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:41:51.548'!
updateRightBoundaryIndex: idx
	Transcript show:'Right bound: ',idx asString, String cr.
	self rightBoundIndex: idx;
		showDebugString.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:42:01.322'!
updateSecondFocusedIndex: idx
	Transcript show:'Second Focus: ',idx asString, String cr.
	self secondFocusedIndex: idx;
		showDebugString.! !

!S2List methodsFor: 'updating' stamp: 'db 6/21/2013 03:58:08.316'!
updateSorted: aBoolean
	self isSorted: aBoolean;
		signalStateChange.! !

Object subclass: #S2User
	instanceVariableNames: ''
	classVariableNames: 'UserName'
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2User class methodsFor: 'as yet unclassified' stamp: 'AT 6/10/2013 15:48:20.344'!
userName
	^UserName! !

!S2User class methodsFor: 'as yet unclassified' stamp: 'AT 6/10/2013 15:55:52.964'!
userName: username
	UserName = username ifFalse: [UserName := username.].! !

UserInterface subclass: #S2AlertUi
	instanceVariableNames: 'label confirmButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2AlertUi commentStamp: 'AT 5/13/2013 19:37:23.986' prior: 0!
"Ui for an S2AlertMorph"!

!S2AlertUi methodsFor: 'accessing' stamp: 'JB 5/21/2013 19:01:54.632'!
confirmButton
	"No description given."
	
	^ confirmButton! !

!S2AlertUi methodsFor: 'ui - private' stamp: 'JB 5/21/2013 19:01:54.66'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	|  |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (300@200).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#center).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#equal).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#center).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: ((Color r: 0.376 g: 0.533 b: 0.976)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	label := UiLabel new.
	label changeTableLayout.
	label extent: (31@19).
	label position: (135@77).
	label hResizing: (#shrinkWrap).
	label vResizing: (#shrinkWrap).
	label minWidth: (2).
	label minHeight: (2).
	label cellInset: (0).
	label cellPositioning: (#center).
	label cellSpacing: (#none).
	label layoutInset: (0).
	label listCentering: (#topLeft).
	label listDirection: (#leftToRight).
	label listSpacing: (#none).
	label maxCellSize: (1073741823).
	label minCellSize: (0).
	label wrapCentering: (#topLeft).
	label wrapDirection: (#none).
	label frameFractions: (0@0 corner: 1@1).
	label frameOffsets: (0@0 corner: 0@0).
	label balloonText: (nil).
	label balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.933)).
	label text: ('Label').
	label setProperty: #formByDesigner toValue: 'nil'.
	label form: (nil).
	label setProperty: #objectName toValue: 'label'.
	panel addChild: label.
	confirmButton := UiPushButton new.
	confirmButton changeTableLayout.
	confirmButton extent: (40@21).
	confirmButton position: (129@100).
	confirmButton hResizing: (#shrinkWrap).
	confirmButton vResizing: (#shrinkWrap).
	confirmButton minWidth: (2).
	confirmButton minHeight: (2).
	confirmButton cellInset: (4).
	confirmButton cellPositioning: (#center).
	confirmButton cellSpacing: (#none).
	confirmButton layoutInset: (10@0 corner: 10@0).
	confirmButton listCentering: (#topLeft).
	confirmButton listDirection: (#leftToRight).
	confirmButton listSpacing: (#none).
	confirmButton maxCellSize: (1073741823).
	confirmButton minCellSize: (0).
	confirmButton wrapCentering: (#topLeft).
	confirmButton wrapDirection: (#none).
	confirmButton frameFractions: (0@0 corner: 1@1).
	confirmButton frameOffsets: (0@0 corner: 0@0).
	confirmButton balloonText: (nil).
	confirmButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.937)).
	confirmButton enabled: (true).
	confirmButton setProperty: #iconByDesigner toValue: 'nil'.
	confirmButton icon: (nil).
	confirmButton text: ('OK').
	confirmButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	confirmButton checkable: (false).
	confirmButton checked: (false).
	confirmButton autoExclusive: (false).
	confirmButton setProperty: #objectName toValue: 'confirmButton'.
	panel addChild: confirmButton.
	panel setProperty: #uiClassName toValue: 'S2Alert'.! !

!S2AlertUi methodsFor: 'accessing' stamp: 'JB 5/21/2013 19:01:54.621'!
label
	"No description given."
	
	^ label! !

UserInterface subclass: #S2AppUi
	instanceVariableNames: 'backButton forwardButton playButton pauseButton resetButton mainContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2AppUi commentStamp: 'AT 5/13/2013 19:38:35.008' prior: 0!
"Ui for an S2App"!

!S2AppUi methodsFor: 'accessing' stamp: 'db 6/21/2013 06:05:01.836'!
backButton
	"No description given."
	
	^ backButton! !

!S2AppUi methodsFor: 'accessing' stamp: 'db 6/21/2013 06:05:01.852'!
forwardButton
	"No description given."
	
	^ forwardButton! !

!S2AppUi methodsFor: 'ui - private' stamp: 'db 6/21/2013 06:05:01.938'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (420@500).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: (Color transparent).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (357@39).
	unnamedMorph1 position: (32@4).
	unnamedMorph1 hResizing: (#shrinkWrap).
	unnamedMorph1 vResizing: (#shrinkWrap).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (5).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#leftToRight).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.949)).
	unnamedMorph1 color: (Color transparent).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	backButton := UiPushButton new.
	backButton changeTableLayout.
	backButton extent: (59@28).
	backButton position: (37@9).
	backButton hResizing: (#spaceFill).
	backButton vResizing: (#spaceFill).
	backButton minWidth: (2).
	backButton minHeight: (2).
	backButton cellInset: (4).
	backButton cellPositioning: (#center).
	backButton cellSpacing: (#none).
	backButton layoutInset: (2@0 corner: 2@0).
	backButton listCentering: (#center).
	backButton listDirection: (#leftToRight).
	backButton listSpacing: (#none).
	backButton maxCellSize: (1073741823).
	backButton minCellSize: (0).
	backButton wrapCentering: (#topLeft).
	backButton wrapDirection: (#none).
	backButton frameFractions: (0@0 corner: 1@1).
	backButton frameOffsets: (0@0 corner: 0@0).
	backButton balloonText: (nil).
	backButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.929)).
	backButton enabled: (true).
	backButton setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0344Normal'.
	backButton icon: (UiDiagonaIcons icon0344Normal).
	backButton text: ('Back').
	backButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	backButton checkable: (true).
	backButton checked: (false).
	backButton autoExclusive: (true).
	backButton setProperty: #objectName toValue: 'backButton'.
	unnamedMorph1 addChild: backButton.
	forwardButton := UiPushButton new.
	forwardButton changeTableLayout.
	forwardButton extent: (81@28).
	forwardButton position: (100@9).
	forwardButton hResizing: (#spaceFill).
	forwardButton vResizing: (#spaceFill).
	forwardButton minWidth: (2).
	forwardButton minHeight: (2).
	forwardButton cellInset: (4).
	forwardButton cellPositioning: (#center).
	forwardButton cellSpacing: (#none).
	forwardButton layoutInset: (2@0 corner: 2@0).
	forwardButton listCentering: (#center).
	forwardButton listDirection: (#leftToRight).
	forwardButton listSpacing: (#none).
	forwardButton maxCellSize: (1073741823).
	forwardButton minCellSize: (0).
	forwardButton wrapCentering: (#topLeft).
	forwardButton wrapDirection: (#none).
	forwardButton frameFractions: (0@0 corner: 1@1).
	forwardButton frameOffsets: (0@0 corner: 0@0).
	forwardButton balloonText: ('click to execute next sort
step').
	forwardButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	forwardButton enabled: (true).
	forwardButton setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0343Normal'.
	forwardButton icon: (UiDiagonaIcons icon0343Normal).
	forwardButton text: ('Forward').
	forwardButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	forwardButton checkable: (true).
	forwardButton checked: (false).
	forwardButton autoExclusive: (true).
	forwardButton setProperty: #objectName toValue: 'forwardButton'.
	unnamedMorph1 addChild: forwardButton.
	playButton := UiPushButton new.
	playButton changeTableLayout.
	playButton extent: (57@28).
	playButton position: (185@9).
	playButton hResizing: (#spaceFill).
	playButton vResizing: (#spaceFill).
	playButton minWidth: (2).
	playButton minHeight: (2).
	playButton cellInset: (4).
	playButton cellPositioning: (#center).
	playButton cellSpacing: (#none).
	playButton layoutInset: (2@0 corner: 2@0).
	playButton listCentering: (#center).
	playButton listDirection: (#leftToRight).
	playButton listSpacing: (#none).
	playButton maxCellSize: (1073741823).
	playButton minCellSize: (0).
	playButton wrapCentering: (#topLeft).
	playButton wrapDirection: (#none).
	playButton frameFractions: (0@0 corner: 1@1).
	playButton frameOffsets: (0@0 corner: 0@0).
	playButton balloonText: ('click to sort all elements').
	playButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	playButton enabled: (true).
	playButton setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0331Normal'.
	playButton icon: (UiDiagonaIcons icon0331Normal).
	playButton text: ('Play').
	playButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	playButton checkable: (true).
	playButton checked: (false).
	playButton autoExclusive: (true).
	playButton setProperty: #objectName toValue: 'playButton'.
	unnamedMorph1 addChild: playButton.
	pauseButton := UiPushButton new.
	pauseButton changeTableLayout.
	pauseButton extent: (67@28).
	pauseButton position: (246@9).
	pauseButton hResizing: (#spaceFill).
	pauseButton vResizing: (#spaceFill).
	pauseButton minWidth: (2).
	pauseButton minHeight: (2).
	pauseButton cellInset: (4).
	pauseButton cellPositioning: (#center).
	pauseButton cellSpacing: (#none).
	pauseButton layoutInset: (2@0 corner: 2@0).
	pauseButton listCentering: (#center).
	pauseButton listDirection: (#leftToRight).
	pauseButton listSpacing: (#none).
	pauseButton maxCellSize: (1073741823).
	pauseButton minCellSize: (0).
	pauseButton wrapCentering: (#topLeft).
	pauseButton wrapDirection: (#none).
	pauseButton frameFractions: (0@0 corner: 1@1).
	pauseButton frameOffsets: (0@0 corner: 0@0).
	pauseButton balloonText: ('click to stop sort animation').
	pauseButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	pauseButton enabled: (true).
	pauseButton setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0341Normal'.
	pauseButton icon: (UiDiagonaIcons icon0341Normal).
	pauseButton text: ('Pause').
	pauseButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	pauseButton checkable: (true).
	pauseButton checked: (false).
	pauseButton autoExclusive: (true).
	pauseButton setProperty: #objectName toValue: 'pauseButton'.
	unnamedMorph1 addChild: pauseButton.
	resetButton := UiPushButton new.
	resetButton changeTableLayout.
	resetButton extent: (66@28).
	resetButton position: (317@9).
	resetButton hResizing: (#spaceFill).
	resetButton vResizing: (#spaceFill).
	resetButton minWidth: (2).
	resetButton minHeight: (2).
	resetButton cellInset: (4).
	resetButton cellPositioning: (#center).
	resetButton cellSpacing: (#none).
	resetButton layoutInset: (2@0 corner: 2@0).
	resetButton listCentering: (#center).
	resetButton listDirection: (#leftToRight).
	resetButton listSpacing: (#none).
	resetButton maxCellSize: (1073741823).
	resetButton minCellSize: (0).
	resetButton wrapCentering: (#topLeft).
	resetButton wrapDirection: (#none).
	resetButton frameFractions: (0@0 corner: 1@1).
	resetButton frameOffsets: (0@0 corner: 0@0).
	resetButton balloonText: ('reset elements').
	resetButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	resetButton enabled: (true).
	resetButton setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0342Normal'.
	resetButton icon: (UiDiagonaIcons icon0342Normal).
	resetButton text: ('Reset').
	resetButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	resetButton checkable: (true).
	resetButton checked: (false).
	resetButton autoExclusive: (true).
	resetButton setProperty: #objectName toValue: 'resetButton'.
	unnamedMorph1 addChild: resetButton.
	panel addChild: unnamedMorph1.
	mainContainer := UiContainer new.
	mainContainer changeTableLayout.
	mainContainer extent: (412@449).
	mainContainer position: (4@47).
	mainContainer hResizing: (#spaceFill).
	mainContainer vResizing: (#spaceFill).
	mainContainer minWidth: (100).
	mainContainer minHeight: (2).
	mainContainer cellInset: (4).
	mainContainer cellPositioning: (#center).
	mainContainer cellSpacing: (#none).
	mainContainer layoutInset: (4).
	mainContainer listCentering: (#topLeft).
	mainContainer listDirection: (#topToBottom).
	mainContainer listSpacing: (#none).
	mainContainer maxCellSize: (1073741823).
	mainContainer minCellSize: (0).
	mainContainer wrapCentering: (#topLeft).
	mainContainer wrapDirection: (#none).
	mainContainer frameFractions: (0@0 corner: 1@1).
	mainContainer frameOffsets: (0@0 corner: 0@0).
	mainContainer balloonText: (nil).
	mainContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	mainContainer color: (Color transparent).
	mainContainer borderWidth: (0).
	mainContainer borderStyle2: (#simple).
	mainContainer borderColor: (Color black).
	mainContainer setProperty: #objectName toValue: 'mainContainer'.
	panel addChild: mainContainer.
	panel setProperty: #uiClassName toValue: 'S2App'.! !

!S2AppUi methodsFor: 'accessing' stamp: 'db 6/21/2013 06:05:01.888'!
mainContainer
	"No description given."
	
	^ mainContainer! !

!S2AppUi methodsFor: 'accessing' stamp: 'db 6/21/2013 06:05:01.872'!
pauseButton
	"No description given."
	
	^ pauseButton! !

!S2AppUi methodsFor: 'accessing' stamp: 'db 6/21/2013 06:05:01.86'!
playButton
	"No description given."
	
	^ playButton! !

!S2AppUi methodsFor: 'accessing' stamp: 'db 6/21/2013 06:05:01.88'!
resetButton
	"No description given."
	
	^ resetButton! !

UserInterface subclass: #S2InputAlertUi
	instanceVariableNames: 'label inputField confirmButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2InputAlertUi methodsFor: 'accessing' stamp: 'AT 6/10/2013 15:39:52.988'!
confirmButton
	"No description given."
	
	^ confirmButton! !

!S2InputAlertUi methodsFor: 'ui - private' stamp: 'AT 6/10/2013 15:39:53.022'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	|  |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (300@200).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#center).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#equal).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#center).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	panel color: ((Color r: 0.376 g: 0.533 b: 0.976)).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	label := UiLabel new.
	label changeTableLayout.
	label extent: (31@19).
	label position: (134@65).
	label hResizing: (#shrinkWrap).
	label vResizing: (#shrinkWrap).
	label minWidth: (2).
	label minHeight: (2).
	label cellInset: (0).
	label cellPositioning: (#center).
	label cellSpacing: (#none).
	label layoutInset: (0).
	label listCentering: (#topLeft).
	label listDirection: (#leftToRight).
	label listSpacing: (#none).
	label maxCellSize: (1073741823).
	label minCellSize: (0).
	label wrapCentering: (#topLeft).
	label wrapDirection: (#none).
	label frameFractions: (0@0 corner: 1@1).
	label frameOffsets: (0@0 corner: 0@0).
	label balloonText: (nil).
	label balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.922)).
	label text: ('Label').
	label setProperty: #formByDesigner toValue: 'nil'.
	label form: (nil).
	label setProperty: #objectName toValue: 'label'.
	panel addChild: label.
	inputField := UiTextEdit new.
	inputField extent: (157@17).
	inputField position: (70@88).
	inputField hResizing: (#rigid).
	inputField vResizing: (#rigid).
	inputField minWidth: (2).
	inputField minHeight: (2).
	inputField cellInset: (0).
	inputField cellPositioning: (#center).
	inputField cellSpacing: (#none).
	inputField layoutInset: (0).
	inputField listCentering: (#topLeft).
	inputField listDirection: (#topToBottom).
	inputField listSpacing: (#none).
	inputField maxCellSize: (1073741823).
	inputField minCellSize: (0).
	inputField wrapCentering: (#topLeft).
	inputField wrapDirection: (#none).
	inputField frameFractions: (0@0 corner: 1@1).
	inputField frameOffsets: (0@0 corner: 0@0).
	inputField balloonText: (nil).
	inputField balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.945)).
	inputField widgetResizable: (true).
	inputField horizontalScrollBarPolicy: (#alwaysOff).
	inputField verticalScrollBarPolicy: (#alwaysOff).
	inputField outerBorderWidth: (1).
	inputField scrollBarThickness: (9).
	inputField theText: ('').
	inputField readOnly: (false).
	inputField autoConvert: (false).
	inputField autoAccept: (false).
	inputField acceptOnFocusLost: (false).
	inputField scrollingMode: (#never).
	inputField scrollingLimit: (10).
	inputField setProperty: #objectName toValue: 'inputField'.
	panel addChild: inputField.
	confirmButton := UiPushButton new.
	confirmButton changeTableLayout.
	confirmButton extent: (40@21).
	confirmButton position: (129@112).
	confirmButton hResizing: (#shrinkWrap).
	confirmButton vResizing: (#shrinkWrap).
	confirmButton minWidth: (2).
	confirmButton minHeight: (2).
	confirmButton cellInset: (4).
	confirmButton cellPositioning: (#center).
	confirmButton cellSpacing: (#none).
	confirmButton layoutInset: (10@0 corner: 10@0).
	confirmButton listCentering: (#topLeft).
	confirmButton listDirection: (#leftToRight).
	confirmButton listSpacing: (#none).
	confirmButton maxCellSize: (1073741823).
	confirmButton minCellSize: (0).
	confirmButton wrapCentering: (#topLeft).
	confirmButton wrapDirection: (#none).
	confirmButton frameFractions: (0@0 corner: 1@1).
	confirmButton frameOffsets: (0@0 corner: 0@0).
	confirmButton balloonText: (nil).
	confirmButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1 alpha: 0.925)).
	confirmButton enabled: (true).
	confirmButton setProperty: #iconByDesigner toValue: 'nil'.
	confirmButton icon: (nil).
	confirmButton text: ('OK').
	confirmButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	confirmButton checkable: (false).
	confirmButton checked: (false).
	confirmButton autoExclusive: (false).
	confirmButton setProperty: #objectName toValue: 'confirmButton'.
	panel addChild: confirmButton.
	panel setProperty: #uiClassName toValue: 'S2InputAlert'.! !

!S2InputAlertUi methodsFor: 'accessing' stamp: 'AT 6/10/2013 15:39:52.972'!
inputField
	"No description given."
	
	^ inputField! !

!S2InputAlertUi methodsFor: 'accessing' stamp: 'AT 6/10/2013 15:39:52.955'!
label
	"No description given."
	
	^ label! !

Morph subclass: #S2AlertMorph
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2AlertMorph commentStamp: 'AT 5/13/2013 19:36:24.1' prior: 0!
"A simple alert Button with a text and a confirm Button"!

!S2AlertMorph class methodsFor: 'creating' stamp: 'JB 5/21/2013 19:03:51.779'!
newWithLabel: aString
	|me|
	me := self new.
	me ui label text: aString.
	^me! !

!S2AlertMorph class methodsFor: 'creating' stamp: 'JB 5/21/2013 19:04:02.565'!
newWithLabel: aLabelString withButtonLabel: aButtonLabelString
	| me |
	me := self newWithLabel: aLabelString.
	me ui confirmButton text: aButtonLabelString.
	^me! !

!S2AlertMorph methodsFor: 'confirming' stamp: 'AT 5/13/2013 19:25:01.811'!
confirm
	self emit.
	self delete.! !

!S2AlertMorph methodsFor: 'confirming' stamp: 'AT 5/13/2013 19:26:17.017'!
confirmButtonClicked
	self confirm.! !

!S2AlertMorph methodsFor: 'initializing' stamp: 'JB 5/21/2013 19:02:43.714'!
initialize
	super initialize.
	self ui setupUi: self.
	self connect: self ui confirmButton signal: #clicked: toSelector: #confirmButtonClicked.! !

!S2AlertMorph methodsFor: 'initializing' stamp: 'AT 5/13/2013 17:28:27.565'!
ui
	^ui ifNil: [ui := S2AlertUi new]! !

S2AlertMorph subclass: #S2InputAlertMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2InputAlertMorph methodsFor: 'as yet unclassified' stamp: 'AT 6/10/2013 15:59:02.611'!
confirm
	self confirm: self ui inputField textMorph text.
	self emit.
	self delete.! !

!S2InputAlertMorph methodsFor: 'as yet unclassified' stamp: 'AT 6/10/2013 15:53:39.202'!
confirm: value
	self emit.! !

!S2InputAlertMorph methodsFor: 'as yet unclassified' stamp: 'JB 6/11/2013 10:55:48.545'!
setInputFieldText: aText
	|text|
	aText 
		ifNil: [ text := '' ]; 		ifNotNil: [text := aText].
	self ui inputField textMorph setCharacters: text.! !

!S2InputAlertMorph methodsFor: 'as yet unclassified' stamp: 'AT 6/10/2013 15:33:12.777'!
ui
	^ui ifNil: [ui := S2InputAlertUi new]! !

Morph subclass: #S2AppMorph
	instanceVariableNames: 'ui app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2AppMorph commentStamp: 'AT 5/13/2013 19:38:08.696' prior: 0!
"Morph for the S2App"!

!S2AppMorph class methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 15:46:38.519'!
newWithApp: anApp
	^ self new app: anApp.! !

!S2AppMorph methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:46:55.8'!
app

	^ app! !

!S2AppMorph methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:46:55.811'!
app: anObject

	app := anObject! !

!S2AppMorph methodsFor: 'initializing' stamp: 'AT 5/13/2013 19:15:30.023'!
initialize
	super initialize.
	self ui setupUi: self.! !

!S2AppMorph methodsFor: 'starting' stamp: 'db 6/21/2013 05:31:34.282'!
initializeControlButtons: aS2ListMorph
	aS2ListMorph connect: self ui forwardButton signal: #pressed toSelector: #forward.
	aS2ListMorph connect: self ui backButton signal: #pressed toSelector: #back.
	aS2ListMorph connect: self ui playButton signal: #pressed toSelector: #startStepping.
	aS2ListMorph connect: self ui pauseButton signal: #pressed toSelector: #stopStepping.
	self app connect: self ui resetButton signal: #pressed toSelector: #resetModel.! !

!S2AppMorph methodsFor: 'accessing' stamp: 'db 5/28/2013 23:43:13.776'!
listModel

	^ listModel! !

!S2AppMorph methodsFor: 'accessing' stamp: 'db 5/28/2013 23:43:13.788'!
listModel: anObject

	listModel := anObject! !

!S2AppMorph methodsFor: 'challenge stepping' stamp: 'AT 5/27/2013 13:52:45.084'!
onWin
	|screen|
	screen := S2AlertMorph newWithLabel: ('Congratulations. You solved the challenge ',String cr, currentChallenge name) withButtonLabel: 'Next Challenge'.
	self showAlert: screen.! !

!S2AppMorph methodsFor: 'initializing' stamp: 'AT 5/13/2013 16:38:24.795'!
open
	self openInWindowLabeled: 'Sortieren2'! !

!S2AppMorph methodsFor: 'layout' stamp: 'db 5/14/2013 20:30:22.436'!
positionForMorph: aMorph
	^ (self position) + (Point x:self width/2 y: self height/2) - (Point x:aMorph width/2 y:aMorph height/2).! !

!S2AppMorph methodsFor: 'starting' stamp: 'AT 6/10/2013 15:55:29.127'!
setUserName: username
	S2User userName: username.! !

!S2AppMorph methodsFor: 'alerting' stamp: 'AT 5/27/2013 14:56:28.733'!
showAlert: anAlert
	self showPopOver: anAlert atPosition: 
	(self positionForMorph: anAlert).! !

!S2AppMorph methodsFor: 'starting' stamp: 'db 6/8/2013 22:50:56.168'!
showInMain: aMorph
	aMorph width: (self ui mainContainer width - (2 * self ui mainContainer layoutInset)).
	aMorph height: (self ui mainContainer height - (2 * self ui mainContainer layoutInset)).
	self ui mainContainer addMorph: aMorph.! !

!S2AppMorph methodsFor: 'as yet unclassified' stamp: 'AT 5/27/2013 14:54:39.63'!
showPopOver: popover atPosition: position
	self addMorph: popover.
	popover disableTableLayout: true.
	popover position: position.! !

!S2AppMorph methodsFor: 'starting' stamp: 'AT 6/10/2013 15:53:19.171'!
showStartScreen
	|startScreen|
	startScreen := (S2InputAlertMorph newWithLabel: 'Welcome to Sorting 2. What is your name?' withButtonLabel: 'Start').
	startScreen setInputFieldText: S2User userName.
	self connect: startScreen signal: #confirm toSelector: #start.
	self connect: startScreen signal: #confirm: toSelector: #setUserName:.
	self showAlert: startScreen.! !

!S2AppMorph methodsFor: 'accessing' stamp: 'JB 6/10/2013 16:12:24'!
start
	self app startFirstChallenge.! !

!S2AppMorph methodsFor: 'starting' stamp: 'db 6/17/2013 17:46:32.054'!
startQuickSortChallenge
	| listMorph |
	self listModel: S2ListModel new.	
	listMorph := S2ListMorphOld new.		
	self sorter: S2QuickSorter new.
	
	self sorter model: self listModel.
	self addMorph: self sorter.
	self resetModelAndSorter.	
	"observer pattern"
	self listModel addDependent: listMorph;
		changed.
	
	self showAlert: listMorph.
	self sorter startSorting.! !

!S2AppMorph methodsFor: 'initializing' stamp: 'AT 5/13/2013 16:12:27.689'!
ui
	^ui ifNil: [ui := S2AppUi new]! !

!S2AppMorph methodsFor: 'accessing' stamp: 'db 5/28/2013 23:43:13.764'!
ui: anObject

	ui := anObject! !

Morph subclass: #S2Sorter
	instanceVariableNames: 'model isSorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2'!

!S2Sorter methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:08:53.499'!
initialize
	super initialize.
	self width: 0;
		height: 0.! !

!S2Sorter methodsFor: 'accessing' stamp: 'JB 6/10/2013 16:35:24.935'!
isSorted
	"Return true if the the model is sorted."
	^ self model isSorted.! !

!S2Sorter methodsFor: 'accessing' stamp: 'db 5/29/2013 04:40:41.458'!
model

	^ model! !

!S2Sorter methodsFor: 'accessing' stamp: 'db 5/29/2013 04:40:41.472'!
model: anObject

	model := anObject
	! !

!S2Sorter methodsFor: 'stepping and presenter' stamp: 'JB 6/10/2013 16:10:19.691'!
nextStep
	^self subclassResponsibility.! !

!S2Sorter methodsFor: 'stepping and presenter' stamp: 'db 5/29/2013 04:40:41.482'!
step
	super step.
	self nextStep.! !

!S2Sorter methodsFor: 'stepping and presenter' stamp: 'db 5/29/2013 04:40:41.496'!
stepTime
	^1000! !

!S2Sorter methodsFor: 'stepping and presenter' stamp: 'db 5/29/2013 04:40:41.508'!
wantsSteps 
	"deactivate stepping on initialization"
	^false! !

TestCase subclass: #S2BubblesorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2BubblesorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:52:41.569'!
testAbortFocusing1
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 3.
	iterator := S2BubblesortIterator newWithList: list.
	self assert: iterator abortFocusing not! !

!S2BubblesorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:52:56.309'!
testAbortFocusing2
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 5.
	list secondFocusedIndex: 6.
	iterator := S2BubblesortIterator newWithList: list.
	self assert: iterator abortFocusing! !

!S2BubblesorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:54:35.832'!
testCompareFocusedElements1
|evaluator list|
	list := S2List new.
	list setupList: #(3 1 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	evaluator := S2BubblesortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements.
	! !

!S2BubblesorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:55:01.394'!
testCompareFocusedElements2
|evaluator list|
	list := S2List new.
	list setupList: #(1 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	evaluator := S2BubblesortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements not.
	! !

!S2BubblesorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:59:34.582'!
testFindLeftIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3) asOrderedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2BubblesortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2BubblesorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 19:01:33.396'!
testFindLeftIndex2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(1 2 3 4 5) asSortedCollection.
	finder := S2BubblesortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2BubblesorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 19:00:01.534'!
testFindLeftIndex3
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(2 3 4 5) asSortedCollection.
	finder := S2BubblesortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2BubblesorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 19:00:53.869'!
testFindRightIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(5) asSortedCollection.
	finder := S2BubblesortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: 4! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:56:40.121'!
testInitSecondFocusedIndex
|finder list|
	list := S2List new.
	list setupList: #(3 1 6 4 7 2) asOrderedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 6.
	finder := S2BubblesortFocusedIndicesFinder newWithList: list.
	self assert: (finder initSecondFocusedIndex) equals: 2.! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:57:24.463'!
testNextFocus1
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 3.
	finder := S2BubblesortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 3.
	self assert: (list secondFocusedIndex) equals: 4.
	! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:57:53.599'!
testNextFocus2
| finder list |
	list := S2List new.
	list setupList: #(1 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	finder := S2BubblesortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 3.
	! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:58:44.994'!
testShouldUpdateFirstFocusedIndex
| finder |
	finder := S2BubblesortFocusedIndicesFinder new.
	self assert: (finder shouldUpdateFirstFocusedIndex).
	! !

!S2BubblesorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:59:02.351'!
testShouldUpdateSecondFocusedIndex
| finder |
	finder := S2BubblesortFocusedIndicesFinder new.
	self assert: (finder shouldUpdateSecondFocusedIndex).
	! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:39:56.246'!
testSort
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:40:49.605'!
testSortAllEqual
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2 2 2) asOrderedCollection.
	sortedList := #(2 2 2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:41:06.671'!
testSortEmpty
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #() asOrderedCollection.
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:41:27.804'!
testSortOne
|sorter sortedList|
	sorter := S2BubbleSorter newWithElements: #(2) asOrderedCollection.
	sortedList := #(2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2BubblesorterTests methodsFor: 'list part sorting' stamp: 'AT 6/17/2013 18:53:50.729'!
testUpdateSortedIndices
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list sortedIndices: #(5) asSortedCollection.
	list firstFocusedIndex: 4.
	partSorter := S2BubblesortListPartSorter newWithList: list.
	partSorter updateSortedIndices.
	self assert: (list sortedIndices) equals: (#(4 5) asSortedCollection).! !

TestCase subclass: #S2ListMorphTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2ListMorphTests methodsFor: 'as yet unclassified' stamp: 'db 6/18/2013 01:38:32.648'!
testHandleElements

	| list morph elements sorter |
	morph := S2ListMorph new openInWorld.
	list := S2List new.
	morph connectTo: list.	
	elements := (1 to: 4) asOrderedCollection shuffled.
	list setupList: elements.

	sorter := S2QuickSorter new.
	sorter setupWithList: list.
	sorter sort.
	self assert: false.! !

TestCase subclass: #S2ListTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:57:59.3'!
testAddElementAsSorted
	| expected list |
	list := S2List new.
	list sortedIndices: #(3 2) asSortedCollection.
	expected := #(4 3 2) asSortedCollection.
	list addIndexAsSorted: 4.
	self assert: (list sortedIndices) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:30:22.982'!
testInsertPivotAt1
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 7.
	expected := #(3 7 1 2 0 8 0 2) asOrderedCollection.
	list insertPivotAt: 3.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:21:25.101'!
testInsertPivotAt2
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 8.
	expected := #(2 3 7 2 0 8 0 1) asOrderedCollection.
	list insertPivotAt: 1.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 18:28:50.913'!
testInsertPivotAt3
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 8 0 0 1 2) asOrderedCollection.
	list insertPivotAt: 7.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 19:25:35.429'!
testInsertPivotAt4
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	list pivotIndex: 4.
	expected := #(3 7 2 0 8 0 1 2) asOrderedCollection.
	list insertPivotAt: 4.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 19:35:55.161'!
testSplit1
	| list |
	list := S2List new.
	list setupList: #(1 2) asOrderedCollection.
	list partitions: #(#(1 2)) asOrderedCollection.
	list splitAfter: 1.
	self assert: (list partitions) equals: (#(#(1) #(2)) asOrderedCollection).! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 19:35:14.568'!
testSplit2
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitions: #(#(1) #(2 3 4)) asOrderedCollection.
	list splitAfter: 3.
	self assert: (list partitions) equals: (#(#(1) #(2 3) #(4)) asOrderedCollection).! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/16/2013 15:52:43.334'!
testSwitchElments
	| expected list |
	list := S2List new.
	list setupList: #(3 7 2 0 8 0 1 2).
	expected := #(3 7 8 0 2 0 1 2) asOrderedCollection.
	list switchElementAt: 3 withElementAt: 5.
	self assert: (list elements) equals: expected.! !

!S2ListTests methodsFor: 'as yet unclassified' stamp: 'AT 6/17/2013 19:47:33.767'!
testaddElementAtToPartitionNo
	| list |
	list := S2List new.
	list setupList: #(1 2 3 4) asOrderedCollection.
	list partitions: #(#(1) #(2 3 4)) asOrderedCollection.
	list addElementAt: 4 toPartitionNo: 1.
	self assert: (list partitions) equals: (#(#(1 4) #(2 3)) asOrderedCollection).! !

TestCase subclass: #S2QuicksorterTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Tests'!

!S2QuicksorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:49:04.866'!
abortFocusing
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list secondFocusedIndex: 3.
	iterator := S2QuicksortListPartSorter newWithList: list.
	self assert: iterator abortFocusing! !

!S2QuicksorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:51:14.3'!
testAbortFocusing1
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 5.
	iterator := S2QuicksortIterator newWithList: list.
	self assert: iterator abortFocusing not! !

!S2QuicksorterTests methodsFor: 'iterating' stamp: 'AT 6/17/2013 18:51:23.746'!
testAbortFocusing2
| list iterator |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list secondFocusedIndex: 3.
	iterator := S2QuicksortIterator newWithList: list.
	self assert: iterator abortFocusing! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:31:06.724'!
testCompareFocusedElements1
|evaluator list|
	list := S2List new.
	list setupList: #(3 1 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements.
	! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:31:13.411'!
testCompareFocusedElements2
|evaluator list|
	list := S2List new.
	list setupList: #(1 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements not.
	! !

!S2QuicksorterTests methodsFor: 'focused elements handling' stamp: 'AT 6/17/2013 18:31:18.908'!
testCompareFocusedElements3
|evaluator list|
	list := S2List new.
	list setupList: #(4 5 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	evaluator := S2QuicksortFocusedIndicesEvaluator newWithList: list.
	self assert: evaluator compareFocusedElements not.
	! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:22:47.153'!
testFindLeftIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3) asOrderedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:22.583'!
testFindLeftIndex2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(1 2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: nil.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:27.663'!
testFindLeftIndex3
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 1.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:32.686'!
testFindLeftIndex4
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asOrderedCollection.
	list sortedIndices: #(1 2 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findLeftIndex) equals: 3.! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:36.905'!
testFindRightIndex1
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(3) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: 2! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:41.698'!
testFindRightIndex2
	|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(1 2 3 4 5) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: nil! !

!S2QuicksorterTests methodsFor: 'list part finding' stamp: 'AT 6/17/2013 18:25:47.003'!
testFindRightIndex3
|finder list|
	list := S2List new.
	list setupList: #(1 2 3 4 5) asSortedCollection.
	list sortedIndices: #(1 2 3 4) asSortedCollection.
	finder := S2QuicksortListPartFinder newWithList: list.
	self assert: (finder findRightIndex) equals: 5! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:40:59.029'!
testInitPivotIndex
|finder list|
	list := S2List new.
	list setupList: #(3 1 6 4 7 2) asOrderedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 6.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	self assert: (finder initPivotIndex) equals: 6.! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:41:22.439'!
testInitSecondFocusedIndex
|finder list|
	list := S2List new.
	list setupList: #(3 1 6 4 7 2) asOrderedCollection.
	list leftBoundIndex: 1.
	list rightBoundIndex: 6.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	self assert: (finder initSecondFocusedIndex) equals: 5.! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:34:34.625'!
testNextFocus1
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 7.
	list pivotIndex: 8.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 7.
	! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:34:52.643'!
testNextFocus2
| finder list |
	list := S2List new.
	list setupList: #(2 5 0 3 4 1 6 3).
	list firstFocusedIndex: 2.
	list secondFocusedIndex: 7.
	list pivotIndex: 8.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder nextFocusedElementsIndices.
	self assert: (list firstFocusedIndex) equals: 2.
	self assert: (list secondFocusedIndex) equals: 6.
	! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:39:16.031'!
testShouldUpdateFirstFocusedIndex
| finder list |
	list := S2List new.
	list setupList: #(1 2 3).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder shouldUpdateFirstFocusedIndex.
	self assert: (finder shouldUpdateFirstFocusedIndex).
	! !

!S2QuicksorterTests methodsFor: 'focused index finding' stamp: 'AT 6/17/2013 18:40:13.178'!
testShouldUpdateSecondFocusedIndex
| finder list |
	list := S2List new.
	list setupList: #(1 3 2).
	list firstFocusedIndex: 1.
	list secondFocusedIndex: 2.
	list pivotIndex: 3.
	finder := S2QuicksortFocusedIndicesFinder newWithList: list.
	finder shouldUpdateFirstFocusedIndex.
	self assert: (finder shouldUpdateSecondFocusedIndex).
	! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 16:53:03.894'!
testSort
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2 5 8 2 6 4 8 2).
	sortedList := #(2 2 2 4 5 6 8 8) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:37.514'!
testSortAllEqual
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2 2 2 2).
	sortedList := #(2 2 2 2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:06.339'!
testSortEmpty
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #().
	sortedList := #() asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'sorter' stamp: 'AT 6/17/2013 17:42:18.016'!
testSortOne
|sorter sortedList|
	sorter := S2QuickSorter newWithElements: #(2).
	sortedList := #(2) asOrderedCollection.
	sorter sort.
	self assert: (sorter list elements) equals: sortedList.! !

!S2QuicksorterTests methodsFor: 'list part sorting' stamp: 'AT 6/17/2013 18:22:22.819'!
testUpdatePivotPosition
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list firstFocusedIndex: 3.
	list pivotIndex: 5.
	partSorter := S2QuicksortListPartSorter newWithList: list.
	partSorter updatePivotPosition.
	self assert: (list elements) equals: #(2 8 2 4 6) asOrderedCollection.! !

!S2QuicksorterTests methodsFor: 'list part sorting' stamp: 'AT 6/17/2013 18:46:19.49'!
testUpdateSortedIndices
	| list partSorter |
	list := S2List new.
	list setupList: #(2 8 4 6 2).
	list sortedIndices: #() asSortedCollection.
	list pivotIndex: 5.
	partSorter := S2QuicksortListPartSorter newWithList: list.
	partSorter updateSortedIndices.
	self assert: (list sortedIndices) equals: (#(5) asSortedCollection).! !
